/* $Header: tyrathect:Development:Perl::RCS:missing.c,v 1.2 1994/05/04 02:12:43 neeri Exp $
 *
 *    Copyright (c) 1996 Matthias Neeracher
 *
 *    You may distribute under the terms of the Perl Artistic License,
 *    as specified in the README file.
 *
 * $Log: missing.c,v $
 */

#define MAC_CONTEXT

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include <Types.h>
#include <Memory.h>
#include <TFileSpec.h>
#include <SpeechRecognition.h>

#define SpeechFail(error)	if (gLastMacOSErr = (error)) { XSRETURN_UNDEF; } else 0

MODULE = Mac::SpeechRecognition	PACKAGE = Mac::SpeechRecognition

SRSpeechObject
SRMakeSpeechObject(obj)
	OSType	obj
	CODE:
	RETVAL = (SRSpeechObject) obj;
	OUTPUT:
	RETVAL

SRSpeechObject
SROpenRecognitionSystem(systemID=0)
	OSType 	systemID
	CODE:
	SpeechFail(SROpenRecognitionSystem(&RETVAL, systemID));
	OUTPUT:
	RETVAL

MacOSRet
SRCloseRecognitionSystem(system)
	SRSpeechObject 	system

MacOSRet
SRSetProperty(srObject, selector, property)
	SRSpeechObject 	srObject
	OSType 			selector
	SV *			property
	CODE:
	{
		STRLEN	propSize;
		char 	buf[256];
		void *	propPtr	= buf;
		switch (selector) {
		case kSRForegroundOnly:
		case kSRBlockBackground:
		case kSRBlockModally:
		case kSRWantsResultTextDrawn:
		case kSRWantsAutoFBGestures:
		case kSRCancelOnSoundOut:
		case kSROptional:
		case kSREnabled:
		case kSRRepeatable:
		case kSRRejectable:
			*(Boolean *)buf	= (Boolean) SvIV(property);
			propSize 	= 1;
			break;
		case kSRFeedbackAndListeningModes:
		case kSRSoundInVolume:
		case kSRListenKeyMode:
		case kSRListenKeyCombo:
		case kSRRejectionLevel:
			*(u_short *)buf	= (u_short) SvIV(property);
			propSize 	= 2;
			break;
		case kSRNotificationParam:
		case kSRSearchStatusParam:
		case kSRRefCon:
			*(u_long *)buf	= (u_long) SvIV(property);
			propSize 	= 4;
			break;
		case kSRLMObjType:
			memcpy(buf, SvPV(property, na), propSize = 4);
			break;
		case kSRRejectedWord:
		case kSRLanguageModelFormat:
		case kSRPathFormat:
		case kSRPhraseFormat:
			if (sv_isa(property, "SRSpeechObject"))
	    		*(SRSpeechObject *)buf = (SRSpeechObject)SvIV((SV*)SvRV(property));
			else
	    		croak("property is not of type SRSpeechObject");
			propSize 	= 4;
			break;
		case kSRReadAudioFSSpec:
			Path2FSSpec((char *) SvPV(property,na), (FSSpec *)buf);
			propSize = sizeof(FSSpec);
			break;
		case kSRListenKeyName:
		case kSRKeyWord:
			CopyC2PStr(SvPV(property,na), (StringPtr) buf);
			propSize = *buf+1;
			break;
		case kSRTEXTFormat:
		case kSRSpelling:
			propPtr = SvPV(property, propSize);
			break;
		}
		RETVAL = SRSetProperty(srObject, selector, propPtr, propSize);
	}
	OUTPUT:
	RETVAL

void
SRGetProperty(srObject, selector)
	SRSpeechObject 	srObject
	OSType 			selector
	CODE:
	{
		STRLEN	propSize;
		char 	buf[256];
		void *	propPtr	= buf;
		*(long *)buf = 0;
		switch (selector) {
		case kSRForegroundOnly:
		case kSRBlockBackground:
		case kSRBlockModally:
		case kSRWantsResultTextDrawn:
		case kSRWantsAutoFBGestures:
		case kSRCancelOnSoundOut:
		case kSROptional:
		case kSREnabled:
		case kSRRepeatable:
		case kSRRejectable:
			propPtr = buf+3;
			propSize= 1;
			break;
		case kSRFeedbackAndListeningModes:
		case kSRSoundInVolume:
		case kSRListenKeyMode:
		case kSRListenKeyCombo:
		case kSRRejectionLevel:
			propPtr = buf+2;
			propSize= 2;
			break;
		case kSRNotificationParam:
		case kSRSearchStatusParam:
		case kSRRefCon:
		case kSRLMObjType:
		case kSRRejectedWord:
		case kSRLanguageModelFormat:
		case kSRPathFormat:
		case kSRPhraseFormat:
			propPtr = buf;
			propSize= 4;
			break;
		case kSRReadAudioFSSpec:
			propPtr = buf;
			propSize= sizeof(FSSpec);
			break;
		case kSRListenKeyName:
		case kSRKeyWord:
		case kSRTEXTFormat:
		case kSRSpelling:
			propPtr = buf;
			propSize= 256;
			break;
		}
		SpeechFail(SRGetProperty(srObject, selector, propPtr, (long *)&propSize));
		/* Should handle buffer too small, but we won't */
		ST(0) = sv_newmortal();
		switch (selector) {
		case kSRForegroundOnly:
		case kSRBlockBackground:
		case kSRBlockModally:
		case kSRWantsResultTextDrawn:
		case kSRWantsAutoFBGestures:
		case kSRCancelOnSoundOut:
		case kSROptional:
		case kSREnabled:
		case kSRRepeatable:
		case kSRRejectable:
		case kSRFeedbackAndListeningModes:
		case kSRSoundInVolume:
		case kSRListenKeyMode:
		case kSRListenKeyCombo:
		case kSRRejectionLevel:
		case kSRNotificationParam:
		case kSRSearchStatusParam:
		case kSRRefCon:
			if (*buf & 0x80)
				sv_setnv(ST(0), (double)*(u_long *)buf);
			else
				sv_setiv(ST(0), *(IV *)buf);
			break;
		case kSRLMObjType:
			sv_setpvn(ST(0), buf, 4);
			break;
		case kSRRejectedWord:
		case kSRLanguageModelFormat:
		case kSRPathFormat:
		case kSRPhraseFormat:
			sv_setref_pv(ST(0), "SRSpeechObject", (void*)*(SRSpeechObject *)buf);
			break;
		case kSRReadAudioFSSpec:
			sv_setpv(ST(0), FSp2FullPath((FSSpec *)buf));
			break;
		case kSRListenKeyName:
		case kSRKeyWord:
			sv_setpvn(ST(0), buf+1, *buf);
			break;
		case kSRTEXTFormat:
		case kSRSpelling:
			sv_setpvn(ST(0), buf, propSize);
			break;
		}
	}

MacOSRet
SRReleaseObject(srObject)
	SRSpeechObject 	srObject

SRSpeechObject
SRGetReference(srObject)
	SRSpeechObject 	srObject
	CODE:
	SpeechFail(SRGetReference(srObject, &RETVAL));
	OUTPUT:
	RETVAL

SRSpeechObject
SRNewRecognizer(system, sourceID = 0)
	SRSpeechObject 	system
	OSType 			sourceID
	CODE:
	SpeechFail(SRNewRecognizer(system, &RETVAL, sourceID));
	OUTPUT:
	RETVAL

MacOSRet
SRStartListening(recognizer)
	SRSpeechObject 	recognizer

MacOSRet
SRStopListening(recognizer)
	SRSpeechObject 	recognizer

MacOSRet
SRSetLanguageModel(recognizer, languageModel)
	SRSpeechObject 	recognizer
	SRSpeechObject 	languageModel

SRSpeechObject
SRGetLanguageModel(recognizer)
	SRSpeechObject 	recognizer
	CODE:
	SpeechFail(SRGetLanguageModel(recognizer, &RETVAL));
	OUTPUT:
	RETVAL

MacOSRet
SRContinueRecognition(recognizer)
	SRSpeechObject 	recognizer

MacOSRet
SRCancelRecognition(recognizer)
	SRSpeechObject 	recognizer

MacOSRet
SRIdle()

SRSpeechObject
SRNewLanguageModel(system, name)
	SRSpeechObject 	system
	SV *			name
	CODE:
	{
		STRLEN	nameLength;
		void *	namePtr = SvPV(name, nameLength);
		SpeechFail(SRNewLanguageModel(system, &RETVAL, namePtr, nameLength));
	}
	OUTPUT:
	RETVAL

SRSpeechObject
SRNewPath(system)
	SRSpeechObject 	system
	CODE:
	SpeechFail(SRNewPath(system, &RETVAL));
	OUTPUT:
	RETVAL

SRSpeechObject
SRNewPhrase(system, text)
	SRSpeechObject 	system
	SV *			text
	CODE:
	{
		STRLEN	textLength;
		void *	textPtr = SvPV(text, textLength);
		SpeechFail(SRNewPhrase(system, &RETVAL, textPtr, textLength));
	}
	OUTPUT:
	RETVAL

SRSpeechObject
SRNewWord(system, text)
	SRSpeechObject 	system
	SV *			text
	CODE:
	{
		STRLEN	textLength;
		void *	textPtr = SvPV(text, textLength);
		SpeechFail(SRNewWord(system, &RETVAL, textPtr, textLength));
	}
	OUTPUT:
	RETVAL

MacOSRet
SRPutLanguageObjectIntoHandle(languageObject, lobjHandle)
	SRSpeechObject 	languageObject
	Handle 			lobjHandle

MacOSRet
SRPutLanguageObjectIntoDataFile(languageObject, fRefNum)
	SRSpeechObject 	languageObject
	short 			fRefNum

SRSpeechObject
SRNewLanguageObjectFromHandle(system, lObjHandle)
	SRSpeechObject 	system
	Handle 			lObjHandle
	CODE:
	SpeechFail(SRNewLanguageObjectFromHandle(system, &RETVAL, lObjHandle));
	OUTPUT:
	RETVAL

SRSpeechObject
SRNewLanguageObjectFromDataFile(system, fRefNum)
	SRSpeechObject 	system
	short 			fRefNum
	CODE:
	SpeechFail(SRNewLanguageObjectFromDataFile(system, &RETVAL, fRefNum));
	OUTPUT:
	RETVAL

MacOSRet
SREmptyLanguageObject(languageObject)
	SRSpeechObject 	languageObject

MacOSRet
SRChangeLanguageObject(languageObject, text)
	SRSpeechObject 	languageObject
	SV *			text
	CODE:
	{
		STRLEN	textLength;
		void *	textPtr = SvPV(text, textLength);
		RETVAL = SRChangeLanguageObject(languageObject, textPtr, textLength);
	}
	OUTPUT:
	RETVAL

MacOSRet
SRAddLanguageObject(base, addon)
	SRSpeechObject 	base
	SRSpeechObject 	addon

MacOSRet
SRAddText(base, text, refCon=0)
	SRSpeechObject 	base
	SV *			text
	long 			refCon
	CODE:
	{
		STRLEN	textLength;
		void *	textPtr = SvPV(text, textLength);
		RETVAL = SRAddText(base, textPtr, textLength, refCon);
	}
	OUTPUT:
	RETVAL

MacOSRet
SRRemoveLanguageObject(base, toRemove)
	SRSpeechObject 	base
	SRSpeechObject 	toRemove

long
SRCountItems(container)
	SRSpeechObject 	container
	CODE:
	SpeechFail(SRCountItems(container, &RETVAL));
	OUTPUT:
	RETVAL

SRSpeechObject
SRGetIndexedItem(container, index)
	SRSpeechObject 	container
	long 			index
	CODE:
	SpeechFail(SRGetIndexedItem(container, &RETVAL, index));
	OUTPUT:
	RETVAL
	

MacOSRet
SRSetIndexedItem(container, item, index)
	SRSpeechObject 	container
	SRSpeechObject 	item
	long 			index

MacOSRet
SRRemoveIndexedItem(container, index)
	SRSpeechObject 	container
	long 			index

MacOSRet
SRDrawText(recognizer, dispText)
	SRSpeechObject 	recognizer
	SV *			dispText
	CODE:
	{
		STRLEN	textLength;
		void *	textPtr = SvPV(dispText, textLength);
		RETVAL = SRDrawText(recognizer, textPtr, textLength);
	}
	OUTPUT:
	RETVAL

MacOSRet
SRDrawRecognizedText(recognizer, dispText)
	SRSpeechObject 	recognizer
	SV *			dispText
	CODE:
	{
		STRLEN	textLength;
		void *	textPtr = SvPV(dispText, textLength);
		RETVAL = SRDrawRecognizedText(recognizer, textPtr, textLength);
	}
	OUTPUT:
	RETVAL

MacOSRet
SRSpeakText(recognizer, speakText)
	SRSpeechObject 	recognizer
	SV *			speakText
	CODE:
	{
		STRLEN	textLength;
		void *	textPtr = SvPV(speakText, textLength);
		RETVAL = SRSpeakText(recognizer, textPtr, textLength);
	}
	OUTPUT:
	RETVAL

MacOSRet
SRSpeakAndDrawText(recognizer, text)
	SRSpeechObject 	recognizer
	SV *			text
	CODE:
	{
		STRLEN	textLength;
		void *	textPtr = SvPV(text, textLength);
		RETVAL = SRSpeakAndDrawText(recognizer, textPtr, textLength);
	}
	OUTPUT:
	RETVAL

MacOSRet
SRStopSpeech(recognizer)
	SRSpeechObject 	recognizer

Boolean
SRSpeechBusy(recognizer)
	SRSpeechObject 	recognizer

MacOSRet
SRProcessBegin(recognizer, failed)
	SRSpeechObject 	recognizer
	Boolean 		failed

MacOSRet
SRProcessEnd(recognizer, failed)
	SRSpeechObject 	recognizer
	Boolean 		failed

