(* BinIO -- SML Basis Library *)

type elem   = Word8.word
type vector = Word8Vector.vector

(* Binary input: *)

type instream 

val openIn       : string -> instream
val closeIn      : instream -> unit
val input        : instream -> vector
val inputAll     : instream -> vector
val inputNoBlock : instream -> vector option
val input1       : instream -> elem option
val inputN       : instream * int -> vector
val endOfStream  : instream -> bool
val lookahead    : instream -> elem option

(* Binary output: *)

type outstream

val openOut      : string -> outstream
val openAppend   : string -> outstream
val closeOut     : outstream -> unit
val output       : outstream * vector -> unit
val output1      : outstream * elem -> unit
val flushOut     : outstream -> unit
