# Unix configuration Makefile for Moscow ML

# Edit MOSMLHOME, CPP and STRIP to suit your installation

MOSMLHOME=${HOME}/mosml

# For Linux and other well-behaved systems, use:
CPP=/lib/cpp -P -traditional -Dunix -Umsdos
STRIP=strip

# For HP-UX, use instead:
# CPP=/lib/cpp -P -Dunix -Umsdos

# For SunOS 5.4 and similar (Solaris 2), use instead:
# CPP=/usr/ccs/lib/cpp -P -Dunix -Umsdos
# STRIP=/usr/ccs/bin/strip

SHELL=/bin/sh

# ---------- You shouldn't need to edit below this line ------------

# BINDIR contains true executable files, such as scripts
# LIBDIR contains bytecode files (such as mosmlcmp and library units)

BINDIR=${MOSMLHOME}/bin
LIBDIR=${MOSMLHOME}/lib
TOOLDIR=${MOSMLHOME}/tools

CAMLRT=../runtime

MOSMLTOOLS=../tools

MOSMLC=../camlrunm ../mosmlcmp -stdlib ../mosmllib -P none
MOSMLL=../camlrunm ../mosmllnk -stdlib ../mosmllib -P none
MOSMLLDOS=../camlrunm ../mosmllnk.dos -stdlib ../mosmllib -P none
MOSMLLNEW=../camlrunm ../mosmllnk.new -stdlib ../mosmllib -P none

MOSMLLEX=../camlrunm ../mosmllex
MOSMLYACC=../mosmlyac/mosmlyac
MOSMLCUT=../camlrunm ../cutdeps 
MOSMLDEP=../camlrunm ../mosmldep

# For cross-compiling to MS DOS (from Linux) (development only)
# CPP=/lib/cpp -P -traditional -Uunix -Dmsdos

CC=gcc

.SUFFIXES :
.SUFFIXES : .sml .sig .ui .uo .mlp .lex .c .o

.sig.ui:
	$(MOSMLC) $(COMPFLAGS) $<

.sml.uo:
	$(MOSMLC) $(COMPFLAGS) $<

.mlp.sml:
	$(CPP) $< > $*.sml

.lex.sml:
	$(MOSMLLEX) $<

.c.o:
	$(CC) -c $(CFLAGS) -o $@ $<
