(* Help *)

val help : string -> unit

val displayLines : int ref

(* 
   [help s] provides on-line help on the topic indicated by string s.  

   help "lib";   gives an overview of the Moscow ML library.

   help "id";    provides help on identifier id (case-insensitive).

   If exactly one identifier in the library matches id (case-insensitive), 
   then the browser opens the signature defining that identifier, 
   positioning the first occurrence of id at the center of the screen.

   If more than one identifier matches id (case-insensitive), then a
   small menu lists the signatures containing the identifier.  To
   invoke the browser, just type in the number of the desired
   signature.

   The browser accepts the following commands, which must be followed
   by a newline:

      d      move down by half a screen
      u      move up by half a screen
      t      move to top of file
      b      move to bottom of file
      /str   cyclically search for string str in help file (case-insensitive)
      n      search for next occurrence of str
      q      quit the browser

   A newline by itself moves down one screen (24 lines).

   [displayLines] is a reference to the size of the display (window)
   assumed by the browser; 24 lines by default.  Set to the actual
   size of your window for best results.  
*)
