#include "all.inc"
#include "color.inc"


#declare Row=0
#declare Col=0
#declare Rows=10
#declare Cols=10

#declare P1 = < 0.00,  0.00,  0.55>
#declare P2 = < 0.00,  0.30,  0.55>

#declare P3 = < 0.40,  0.30,  0.15>
#declare P4 = < 0.75,  0.30,  0.55>
#declare P5 = < 0.75,  0.30,  0.15>
#declare P6 = < 0.85,  0.30,  0.35>

#declare P7 = < 0.90,  0.30,  0.15>
#declare P8 = < 0.90,  0.00,  0.15>

#declare R1 = 0.02
#declare R2 = R1 * 0.9
#declare R3 = R2 * 0.9
#declare R4 = R3 * 0.9
#declare R5 = R4 * 0.9
#declare R6 = R5 * 0.9
#declare R7 = R5 * 0.9
#declare R8 = R5 * 0.9

union {
    union {
        #while(Row < Rows)
        #declare Col=0
            #while(Col < Cols)
                superellipsoid { <0.5, 0.5> scale 0.0475 translate <Row/Rows,
0.05, Col/Cols>
                    #if( (mod(Row,4)=0) )
                        texture { T_Red }
                    #else
                        texture { T_Green }
                    #end
                }
               #declare Col=Col+1
            #end
       #declare Row=Row+1
    #end

        union {

          sphere { P1, R1  texture { T_Red } }
          cone { P1, R1, P2 , R2
              texture { T_Red }
          }

          sphere { P2, R2  texture { T_Red }}
          cone { P2, R2, P3 , R3
              texture { T_Red }
          }

          sphere { P3, R3  texture { T_Red } }
          cone { P3, R3, P4, R4
              texture { T_Red }
          }

          sphere { P4, R4 texture { T_Red } }
          cone { P4, R4, P5, R5
            texture { T_Red }
          }
          sphere { P5, R5 texture { T_Red } }
          cone { P5, R5, P6, R6
            texture { T_Red }
          }
          sphere { P6, R6  texture { T_Red } }
          cone { P6, R6, P7, R7
              texture { T_Red }
          }
          sphere { P7, R7  texture { T_Red } }
          cone { P7, R7, P8, R8
              texture { T_Red }
          }

          sphere { P8, R8  texture { T_Red } }
          translate y*0.1
      }

      text { ttf "crystal.ttf", "P", 1, 0
         scale <0.25, 0.25, 0.05>
         translate P1 + <-0.1, 0.15, 0>
         texture { T_Red }
         no_shadow
      }

      text { ttf "crystal.ttf", "Q", 1, 0
         scale <0.25, 0.25, 0.05>
         translate P8 + <0.1, 0.15, 0>
         texture { T_Red }
         no_shadow
      }

      text { ttf "crystal.ttf", "1st move", 0.33, 0
         scale <0.115, 0.15, 0.02>
         rotate y * 45
         translate (P2) + (y * 0.125)
         texture { T_Green finish {ambient 0.2} }
         no_shadow
      }

      text { ttf "crystal.ttf", "2nd move", 0.33, 0
         scale <0.115, 0.15, 0.02>
         rotate -y * 45
         translate P3 + (y * 0.125)
         texture { T_Green finish {ambient 0.2} }
         no_shadow
      }

      scale 3
      translate <-1.5, -1, -1.5>
      texture { T_Red }                  // dummy texture to avoid warning
      no_shadow
    }
    rotate -y * 15
}

