/*==============================================================================
Project:	POV

Version:	3

File:		PovMacProto.c

Description:
	prototypes of external routines from POV.C, needed by other parts of the engine.
------------------------------------------------------------------------------
Author:
	Eduard [esp] Schwan
------------------------------------------------------------------------------
	from Persistence of Vision(tm) Ray Tracer
	Copyright 1996 Persistence of Vision Team
------------------------------------------------------------------------------
	NOTICE: This source code file is provided so that users may experiment
	with enhancements to POV-Ray and to port the software to platforms other 
	than those supported by the POV-Ray Team.  There are strict rules under
	which you are permitted to use this file.  The rules are in the file
	named POVLEGAL.DOC which should be distributed with this file. If 
	POVLEGAL.DOC is not available or for more info please contact the POV-Ray
	Team Coordinator by leaving a message in CompuServe's Graphics Developer's
	Forum.  The latest version of POV-Ray may be found there as well.

	This program is based on the popular DKB raytracer version 2.12.
	DKBTrace was originally written by David K. Buck.
	DKBTrace Ver 2.0-2.12 were written by David K. Buck & Aaron A. Collins.
------------------------------------------------------------------------------
Change History:
==============================================================================*/

#if !defined(POVMACPROTO_H)
#define POVMACPROTO_H

#include <types.h>

/*==== pov.c Prototypes ====*/

void	catch_exit(int n);
void	Cooperate(int doImmediate);

OSErr SetCurrentDirToAppDir(void);
Boolean AppIsQuitting(void);
void SetAppQuit(void);
void PrintMacCredits(void);
void DisableMenus(void);
void EnableMenus(void);


// these are needed by AEUtils
void	DoFile_New(void);
void	DoFile_Open(void);
void	OpenTextFile(Str255 fn, short vRef, long dirID, Boolean UseDirID);

void	Cooperate(int doImmediate);
void	exit_handler(void);


#endif // POVMACPROTO_H
