/*
==============================================================================
Project:	POV-Ray

Version:	3

File Name:	ProgressDialog.h

Description:
	General-purpose progress bar handling for dialogs.

	This is the header file, containing the public definitions for
	the useful external functions.

Related Files:
	ProgressDialog.c	- Main implementation for these routines
------------------------------------------------------------------------------
Author:
	Eduard [esp] Schwan
------------------------------------------------------------------------------
	from Persistence of Vision(tm) Ray Tracer
	Copyright 1996 Persistence of Vision Team
------------------------------------------------------------------------------
	NOTICE: This source code file is provided so that users may experiment
	with enhancements to POV-Ray and to port the software to platforms other 
	than those supported by the POV-Ray Team.  There are strict rules under
	which you are permitted to use this file.  The rules are in the file
	named POVLEGAL.DOC which should be distributed with this file. If 
	POVLEGAL.DOC is not available or for more info please contact the POV-Ray
	Team Coordinator by leaving a message in CompuServe's Graphics Developer's
	Forum.  The latest version of POV-Ray may be found there as well.

	This program is based on the popular DKB raytracer version 2.12.
	DKBTrace was originally written by David K. Buck.
	DKBTrace Ver 2.0-2.12 were written by David K. Buck & Aaron A. Collins.
------------------------------------------------------------------------------
Change History:
	920820	[esp]	Created
	920920	[esp]	changed highestVal from int to long
	930619	[esp]	added dispose fn
	931001	[esp]	version 2.0 finished (Released on 10/4/93)
	931119	[djh]	brought into conformance with PPCC header requirements
==============================================================================
*/

#if !defined(PROGRESSDIALOG_H)
#define PROGRESSDIALOG_H


#include "config.h"
#include <dialogs.h>	// DialogPtr


DialogPtr	GetNewProgressDialog(short theDialogID, short theProgressItemNum);

void		updateProgressDialog(DialogPtr pDialogPtr, long lowestVal, long highestVal, long currentVal);

void		disposeProgressDialog(DialogPtr pDialogPtr);


#endif // PROGRESSDIALOG_H

