/*==============================================================================
Project:	POV-Ray

Version:	3

File:	povtcpch.c

Description:
	Think C requires any pre-compiled header (PCH) file
	to end in ".c", so this is a shell file that simply
	includes the generic ".PCH" pre-compiled header file.
	-------------------------------------------
	PRECOMPILE this and save this as:
		"POVTPM68K" for the 68k compiler, or
		"POVSPMPPC" for the PPC compiler.
	-------------------------------------------
------------------------------------------------------------------------------
Author:
	Eduard [esp] Schwan
------------------------------------------------------------------------------
	from Persistence of Vision(tm) Ray Tracer
	Copyright 1996 Persistence of Vision Team
------------------------------------------------------------------------------
	NOTICE: This source code file is provided so that users may experiment
	with enhancements to POV-Ray and to port the software to platforms other 
	than those supported by the POV-Ray Team.  There are strict rules under
	which you are permitted to use this file.  The rules are in the file
	named POVLEGAL.DOC which should be distributed with this file. If 
	POVLEGAL.DOC is not available or for more info please contact the POV-Ray
	Team Coordinator by leaving a message in CompuServe's Graphics Developer's
	Forum.  The latest version of POV-Ray may be found there as well.

	This program is based on the popular DKB raytracer version 2.12.
	DKBTrace was originally written by David K. Buck.
	DKBTrace Ver 2.0-2.12 were written by David K. Buck & Aaron A. Collins.
------------------------------------------------------------------------------
Change History:
	960210	[esp]	Created
	960407	[esp]	added pack_enums
	961007	[esp]	added _NOCONSOLE_ per Steven Cartier (jewels@qnet.com)
==============================================================================*/

// The project requires that we have ENUMS ALWAYS INT turned on, but this
// seems to cause major problems with TPM when precompiling Apple's
// header files, so we turn it OFF for precompiling... (which means we
// turn ON packing of enums!)

#pragma options(pack_enums)

// turn off I/O console window stuff
#define _NOCONSOLE_

// simply include the general purpose .PCH file
#include "povmacheaders.pch"
