/*==============================================================================
Project:	POV

Version:	3

File:	sysMacPict.h

Description:
This module contains all defines, typedefs, and prototypes for sysmacpict.C.
(System-dependent image_map file format read/write routines - for Macintosh PICT)
------------------------------------------------------------------------------
Author:
	Eduard [esp] Schwan
------------------------------------------------------------------------------
	from Persistence of Vision(tm) Ray Tracer
	Copyright 1996 Persistence of Vision Team
------------------------------------------------------------------------------
	NOTICE: This source code file is provided so that users may experiment
	with enhancements to POV-Ray and to port the software to platforms other 
	than those supported by the POV-Ray Team.  There are strict rules under
	which you are permitted to use this file.  The rules are in the file
	named POVLEGAL.DOC which should be distributed with this file. If 
	POVLEGAL.DOC is not available or for more info please contact the POV-Ray
	Team Coordinator by leaving a message in CompuServe's Graphics Developer's
	Forum.  The latest version of POV-Ray may be found there as well.

	This program is based on the popular DKB raytracer version 2.12.
	DKBTrace was originally written by David K. Buck.
	DKBTrace Ver 2.0-2.12 were written by David K. Buck & Aaron A. Collins.
------------------------------------------------------------------------------
Change History:
==============================================================================*/

#ifndef SYSMACPICT_H
#define SYSMACPICT_H

/*****************************************************************************
* Global preprocessor defines
******************************************************************************/



/*****************************************************************************
* Global typedefs
******************************************************************************/



/*****************************************************************************
* Global variables
******************************************************************************/



/*****************************************************************************
* Global functions
******************************************************************************/

FILE_HANDLE *Get_MacPICT_File_Handle PARAMS((void));
char *Default_MacPICT_File_Name PARAMS((void));
int Open_MacPICT_File PARAMS((FILE_HANDLE *handle, char *name,
                          int *width, int *height, int buffer_size, int mode));
void Write_MacPICT_Line PARAMS((FILE_HANDLE *handle, COLOUR *line_data, int line_number));
int Read_MacPICT_Line PARAMS((FILE_HANDLE *handle, COLOUR *line_data, int *line_number));
int Read_MacPICT_Int_Line PARAMS((FILE_HANDLE *handle, IMAGE_LINE *line_data, int *line_number));
void Read_MacPICT_Image PARAMS((IMAGE *Image, char *filename));
void Close_MacPICT_File PARAMS((FILE_HANDLE *handle));

#endif
