#ifndef __HFABUTILSCOMMON__
#define __HFABUTILSCOMMON__


#ifndef __FSPCOMPAT__
#include <FSpCompat.h>
#endif

#if defined(FabSystem7orlater)

#define	FabStandardGetFile(a,b,c,d)	StandardGetFile(a,b,c,d)
#define	FabStandardPutFile(a,b,c)	StandardPutFile(a,b,c)

#else

#include	"Utils6.h"

#endif

enum
{
kCacheMask   = 0x0010,
kNoCacheMask = 0x0020
};


/*	kScrollbarAdjust and kScrollbarWidth are used in calculating
	values for control positioning and sizing. */
enum {
kScrollbarAdjust = 15,
kScrollbarWidth
};

/* Menu list resource IDs */
enum menures {
kRes_Menu_Apple = 128,
kRes_Menu_File,
kRes_Menu_Edit
};

enum edititems {
kMItem_Undo = 1,
kMItem_Cut = 3,
kMItem_Copy,
kMItem_Paste,
kMItem_Clear,
kMItem_Select_All
};

enum {
kUndoKey = 0x7A10,
kCutKey = 0x7810,
kCopyKey = 0x6310,
kPasteKey = 0x7610,
kHelpKey = 0x7205,
kFwdDel = 0x757F,
kHomeKey = 0x7301,
kEndKey = 0x7704,
kPgUpKey = 0x740B,
kPgDnKey = 0x790C,
kClearKey = 0x471B,
kEscapeKey = 0x351B,
kEnterKey = 0x4C03
};

/* for KeyState */
enum {
kCommandKeyCode = 55,
kShiftKeyCode,
kCapsLockKeyCode,
kOptionKeyCode,
kControlKeyCode
};

enum {
kWantRestart = false,
kWantShutdown = true
};

enum {
kCreat = 'FABR',
kAEAlert = 'ALRT'
};

enum {
kDITLItem_AboutPICT = 3,
kItemUserName = 3,
kItemCompany,
kItemAddress,
kItemCity,
kItemState,
kItemZIP,
kItemCountry,
kItemE_mail,
kItemPhone,
kItemFAX,
kItemQuantity,
kItemCopyFrom,
kItemComments,
kItemTotals = 27
};

enum {
kFSMacintosh = 0,
kFSProDOS = 0x100,
kFSMSDOS = 0x4953
};

enum {
kAsyncThreadStackSize = 2048UL,
kSleepAsync = 90UL,
kSleepThreading = 0UL,
kStdSectorSize = 512,
kTagBytesxSector = 12
};

#define	kMyZFMacPlus	5
#define	kDragMFMacPlus	5

#define	gestaltBgndMouseDownSupport	10

typedef struct {
	FSSpec	destFile;
	ScriptCode	theScript;
	} StdFileResult, *StdFileResultPtr;

/* dialog box manager */

struct dialogitems {
	short	itemNumber;
	short	group;
	long	refCon;
	};

typedef struct dialogitems dialogItems, *dialogItemsPtr;

struct wakeupCntrlParam {
	Ptr		bufferLimit;
	ProcessSerialNumber	mypsn;
	CntrlParam		pb;
	};

typedef struct wakeupCntrlParam wakeupCntrlParam, *wakeupCntrlParamPtr;

struct wakeupIOParam {
	Ptr		bufferLimit;
	ProcessSerialNumber	mypsn;
	IOParam		pb;
	};

typedef struct wakeupIOParam wakeupIOParam, *wakeupIOParamPtr;

struct wakeupHVolumeParam {
	Ptr		bufferLimit;
	ProcessSerialNumber	mypsn;
	HVolumeParam		pb;
	};

typedef struct wakeupHVolumeParam wakeupHVolumeParam, *wakeupHVolumeParamPtr;

struct wakeupHParamBlockRec {
	Ptr		bufferLimit;
	ProcessSerialNumber	mypsn;
	HParamBlockRec		pb;
	};

typedef struct wakeupHParamBlockRec wakeupHParamBlockRec, *wakeupHParamBlockPtr;

struct ZoomFactorRec {
	short		myFactor;
	short		DragMFactor;
	};

typedef struct ZoomFactorRec ZoomFactorRec;

//=============================================================================

#if PRAGMA_IMPORT_SUPPORTED
#pragma import on
#endif

typedef pascal OSErr (*BkgClickHandlerProcPtr)(const EventRecord *event, SInt16 *action);

#if GENERATINGCFM
typedef UniversalProcPtr BkgClickHandlerUPP;
#else
typedef BkgClickHandlerProcPtr BkgClickHandlerUPP;
#endif

enum {
	uppBkgClickHandlerProcInfo = kPascalStackBased
		 | RESULT_SIZE(SIZE_CODE(sizeof(OSErr)))
		 | STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(EventRecord *)))
		 | STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(SInt16 *)))
};

#if GENERATINGCFM
#define NewBkgClickHandlerProc(userRoutine)		\
		(BkgClickHandlerUPP) NewRoutineDescriptor((ProcPtr)(userRoutine), uppBkgClickHandlerProcInfo, GetCurrentArchitecture())
#else
#define NewBkgClickHandlerProc(userRoutine)		\
		((BkgClickHandlerUPP) (userRoutine))
#endif
/*
#if GENERATINGCFM
#define CallSelectorFunctionProc(userRoutine, selector, response)		\
		CallUniversalProc((UniversalProcPtr)(userRoutine), uppBkgClickHandlerProcInfo, (selector), (response))
#else
#define CallSelectorFunctionProc(userRoutine, selector, response)		\
		(*(userRoutine))((selector), (response))
#endif
*/
extern pascal OSErr InstallBackgroundClickHandler(BkgClickHandlerUPP bkgHandler)
 THREEWORDINLINE(0x3F3C, 0x0055, 0xA88F);

#if PRAGMA_IMPORT_SUPPORTED
#pragma import off
#endif

#pragma internal on

/* WantThisHandleSafe locks high the handle and returns the previous state */

#if GENERATING68K
#pragma parameter __D0 WantThisHandleSafe(__A0)
extern pascal SignedByte WantThisHandleSafe(Handle myH) = {0xA069, 0x1F00, 0xA064, 0xA029, 0x101F};
#else
SignedByte WantThisHandleSafe(Handle myH);
#endif

#if GENERATING68K
#pragma parameter __D0 AMultBDivC(__D0,__D1,__D2)
extern pascal SInt16 AMultBDivC(SInt16 a, SInt16 b, SInt16 c) = {0xC1C1, 0x81C2};
#else
int AMultBDivC(int a, int b, int c);
#endif

#if GENERATING68K
#pragma parameter MyZeroBuffer(__A0,__D1)
extern pascal void MyZeroBuffer(long *p, long s) = {0x7000, 0x20C0, 0x51C9, 0xFFFC };

#pragma parameter MyFillBuffer(__A0,__D1,__D0)
extern pascal void MyFillBuffer(long *p, long s, long filler) = {0x20C0, 0x51C9, 0xFFFC };

#pragma parameter __D0 mySwap(__D0)
extern pascal long mySwap(long s) = {0x4840 };
#else
void MyZeroBuffer(long *p, long s);
void MyFillBuffer(long *p, long s, long filler);
long mySwap(long s);
#endif

void ZoomingRects(ZoomFactorRec * const zfr, const Rect * const firstRect, const Rect * const lastRect, ZoomAcceleration acc);
OSErr AddSTRRes2Doc(const FSSpecPtr theDoc, OSType myFcrea, OSType myFtype, short STRid, ScriptCode lScript);
OSErr AddSTRHand2Doc(const FSSpecPtr theDoc, OSType myFcrea, OSType myFtype, StringHandle msgString, ScriptCode lScript);
OSErr AddRes2Doc(const FSSpecPtr theDoc, Handle thisHandle, ResType rType, short rID);
OSErr AddRes2DocOpen(Handle thisHandle, ResType rType, short rID);
void SendmyAE(AEEventClass, AEEventID myAEvtID, AEIdleProcPtr, AESendMode theMode);
void SendmyAEPShort(AEEventClass myclass, AEEventID myAEvtID, AEIdleProcPtr IdleFunct, AESendMode theMode, short theAlert);
OSErr SendRevealToFinder(Handle fld, AEIdleProcPtr IdleFunct,
						void (*failProc)(void));
Handle NewHandleGeneral(UInt32 blockSize);
Handle Get1ResGeneral(ResType theType, short theID);
OSType FindFinderAtEaseProcess(ProcessSerialNumber * const);
OSType FindFinderProcess(void);
OSErr SendShutdownToFinder(AEIdleProcPtr, Boolean);
short StopAlert_UPP(short alertID, ModalFilterProcPtr filterProc);
short StopAlert_AE(short alertID, ModalFilterProcPtr filterProc, AEIdleProcPtr IdleFunct);
short CautionAlert_UPP(short alertID, ModalFilterProcPtr filterProc);
short CautionAlert_AE(short alertID, ModalFilterProcPtr filterProc, AEIdleProcPtr IdleFunct);
short NoteAlert_UPP(short alertID, ModalFilterProcPtr filterProc);
short NoteAlert_AE(short alertID, ModalFilterProcPtr filterProc, AEIdleProcPtr IdleFunct);
short Alert_UPP(short alertID, ModalFilterProcPtr filterProc);
short Alert_AE(short alertID, ModalFilterProcPtr filterProc, AEIdleProcPtr IdleFunct);


short HandleDialog(ModalFilterProcPtr filterProc,
					dialogItemsPtr things,
					void (*initProc)(DialogRef),
					void (*userProc)(DialogRef, Handle, short),
					short resId);

/* about box manager */

void myAbout(void (*theIdleProc)(void),
			UserItemUPP DrawQTPict,
			void (*UpdateProc)(EventRecord *),
			void (*ActivateProc)(EventRecord *)
			);
Handle OpenSplash(DialogRef * const, UserItemUPP DrawQTPict);
void DisposeSplash(Handle, DialogRef);
void myMovableModalAbout(
			Point *aboutTopLeft,
			Point *creditsTopLeft,
			void (*AdjustMenus)(TEHandle),
			void (*Handle_My_Menu)(long),
			void (*DomyKeyEvent)(EventRecord *),
			void (*DoUpdate)(EventRecord *),
			void (*DoActivate)(EventRecord *),
			void (*DoHiLevEvent)(EventRecord *),
			void (*DoOSEvent)(EventRecord *),
			void (*DoIdle)(void),
			unsigned long minSleep
			);

void CopyEMailAddrToClip(void);
void CopyWWWURLToClip(short);
Boolean GetFontNumber(ConstStr255Param fontName, short * const fontNum);
Boolean CmdPeriodOrEsc(const EventRecord * const theEvent);
Boolean CmdPeriodOrEscConfirm(const EventRecord * const theEvent, short alertID, ModalFilterProcPtr filterProc);
void HandleRegistration(/*ModalFilterProcPtr filterProc,*/
						Point *regDTopLeft,
						long (*regCfgInfo)(Handle, long, StringPtr),
						void (*AdjustMenus)(TEHandle),
						void (*Handle_My_Menu)(long),
						void (*DomyKeyEvent)(EventRecord *),
						void (*DoUpdate)(EventRecord *),
						void (*DoActivate)(EventRecord *),
						void (*DoHiLevEvent)(EventRecord *),
						void (*DoOSEvent)(EventRecord *),
						void (*DoIdle)(void),
						UInt32 minSleep,
						UInt16 dollars);
void CopyBugReportForm(long (*regCfgInfo)(Handle, long, StringPtr));
OSErr AskForDestFile(StdFileResultPtr whichFile, ConstStr255Param prompt, StringPtr docName);
void BCDVersNumToString(long num, StringPtr str);
void BCDLongVersNumToString(long num, StringPtr str);
Boolean TrapAvailable(short theTrap);
OSErr InstallRequiredAEHandlers(AEEventHandlerProcPtr myOAPP,
								AEEventHandlerProcPtr myODOC,
								AEEventHandlerProcPtr myPDOC,
								AEEventHandlerProcPtr myQUIT);
void FileCreationError(OSErr err);

#pragma internal reset

//====================================================================

//#if GENERATING68K
//#pragma parameter MyNumToString(__D0,__A0)
//extern pascal void MyNumToString(long theNum,Str255 theString)
// TWOWORDINLINE(0x4267, 0xA9EE);
//#else
#define	MyNumToString	NumToString
//#endif

/*
#ifdef	FABERDEBUG
#define	SAFEDESTROY(disposFn, type, obj, realtype)	{disposFn((type)obj); obj = (realtype)0xDEADBEEF;}
#else
*/
#define	SAFEDESTROY(disposFn, type, obj, realtype)	{disposFn((type)obj); obj = nil;}
//#endif

#define	SSAFEDESTROY(disposFn, type, obj, realtype)	if (obj) SAFEDESTROY(disposFn, type, obj, realtype)


#define numOfLongs(s)	((((UInt32)s)>>2) - 1L)

#define toMenu(m, i)	(((long)m << 16) + i)
#define	CHARFROMMESSAGE(mess)	(*(((unsigned char *)(&(mess))) + 3))
#define ISAPPWINDOW(w)	(((WindowPeek) w)->windowKind >= userKind)
#define ISDLGWINDOW(w)	(((WindowPeek) w)->windowKind == dialogKind)
#define ISDAWINDOW(w)	(((WindowPeek) w)->windowKind < 0)
#define isMovableModal(w)	(GetWVariant(w) == movableDBoxProc)

#define MAX(a, b)	((a) > (b) ? (a) : (b))
#define MIN(a, b)	((a) < (b) ? (a) : (b))

/* Define HiWrd and LoWrd macros for efficiency. */
#define HiWrd(aLong)	(short)(((UInt32)aLong) >> 16)
#define LoWrd(aLong)	(short)((aLong) & 0xFFFF)

#define PRCT_T(f)	(f->portRect.top)
#define PRCT_L(f)	(f->portRect.left)
#define PRCT_B(f)	(f->portRect.bottom)
#define PRCT_R(f)	(f->portRect.right)

#define rheight(r)	((r).bottom - (r).top)
#define rwidth(r)	((r).right - (r).left)

#endif
