/*
	HASDialogs.h from Hsoi's App Shell.   1995-1997 John C. Daub.  All rights reserved.
	
	This file contains the header information (function prototypes, constants, resource
	ID's, etc) for dialogs and HASDialogs.c
*/

#ifndef __DIALOGS__
#include <Dialogs.h>
#endif

//========================
// Constants
//========================

/*
 *	constants for the min and max font sizes
 */

enum {
	kMinFontSize	=	1,
	kMaxFontSize	=	500
};



//========================
// Resource IDs
//========================

/*
 *	'ALRT' resource numbers
 */

enum {
	rGenericErrorAlert		=	129,
	rIllegalFontSizeAlert	=	130,
	rSaveChangesAlert		=	131,
	rRevertAlert			=	134,
	rFileLockedAlert		=	135,
	rNMRespAlert			=	136,
	rPrefsErrorAlert		=	137
};

/*
 * 'DLOG' resource numbers, and their associated 'DITL' item numbers
 */


enum {
	rAboutBoxDLOG			= 128,
	iAboutBoxAppName		= 3,
	iAboutBoxCopyright		= 4,
	iAboutBoxUser			= 6,
	iAboutBoxIcon			= 8,
	iAboutBoxOrg			= 11
};


enum {
	rRegistrationDialog			=	138,
	iRegDialogUserName			=	5,
	iRegDialogOrgName			=	7
};


enum {
	rOtherFontSizeDialog		=	133,
	iOtherSizeSizeEditText		=	4
};

enum {
	rSplashScreen				=	139
};

enum {
	rModalDialog			=	200,
//	ok and cancel set in Dialogs.h
	iTitleItem				=	3,
	iIconItem				=	4,
	iBottomEditLine			=	5,
	iSpinItem				=	6,
	iTopEditLine			=	7,
	iEditCheckBox			=	8,
	iDimmingBox				=	9,
	iSayClickIcon			=	10,
	iScrollControlItem		=	11,
	iSayRotationSpeedItem	=	12,
	iSlowWordItem			=	13,
	iFastWordItem			=	14,
	iStatTextVaryItem		=	15,
	iEditTextVaryItem		=	16,
	iVaryTextCheckBoxItem	=	17,
	iBorderBox				=	18,
	iRadioButtonOne			=	19,
	iRadioButtonTwo			=	20,
	iRadioButtonThree		=	21,
	
	kRadioButtonFirst		=	iRadioButtonOne,
	kRadioButtonLast		=	iRadioButtonThree
};

enum {
	rModelessDialog				=	201
};

enum {
	rMovableModalProgressDialog		=	202,
	iMMProgressOKButton				=	ok,	// item number 1, defined in Dialogs.h
	iMMProgressStaticText			=	2,
	iMMProgressBar					=	3
};	



//========================
// #defines
//========================



//========================
// Function Prototypes
//========================

pascal Boolean	hsoiMyStandardDialogFilter( DialogRef, EventRecord *, short * );
pascal ModalFilterUPP HsoiGetMyStandardDialogFilter( void );
short			HsoiGetDialogItemType( DialogRef, short );
Handle			HsoiGetDialogItemHandle( DialogRef, short );
void			HsoiGetDialogItemRect( DialogRef, short, Rect * );
pascal void		HsoiSetDialogItemProc( DialogRef, short, UserItemUPP );
void			HsoiDoAboutBox( void );
Boolean			HsoiDoSplashScreen( void );
long			HsoiDoOtherFontSize( WindowRef );
pascal Boolean 	hsoiOtherFontSizeDialogFilter( DialogRef, EventRecord *, short * );
void			HsoiDoIllegalFontSize( void );
void			HsoiDoModalDialog( void );
pascal Boolean	hsoiFilterIt( DialogRef, EventRecord *, short * );
void			HsoiSetDialogItemState( DialogRef, short, short );
void			HsoiSetRadioButton( DialogRef, short );
void			HsoiSpinIt( DialogRef );
pascal void		HsoiBorderDefault( DialogRef, short );
pascal void		HsoiDimEditLine( WindowRef, short );
Boolean			HsoiIsEditKey( char, short );
ControlRef		HsoiSnatchHandle( DialogRef, short );
pascal void		HsoiDoScrollArrows( ControlRef, short );
//COPLAND - this entire function breaks under STRICT macros cause of it's
// use of a DialogPeek
short			HsoiHasSelectionRange( DialogPeek );
void			HsoiDoModelessDialog( void );
void			HsoiDoDialogHit( DialogRef, short );
void			HsoiDoMovableModalDialog( void );
void			HsoiInitProgressIndicator( GrafPtr, Rect, long );
void			HsoiSetProgress( long );
Boolean			HsoiSetProgressDelta( long );
void			HsoiDrawProgressBar( void );
void			HsoiUpdateProgressBar( void );
void			HsoiSetFrameColor( void );
void			HsoiSetDoneColor( void );
void			HsoiSetToDoColor( void );
