/*	
	HASGlobals.h from Hsoi's App Shell.   1995-1997 John C. Daub.  All rights reserved.

	Contains the external declarations of the global variables, plus global
	struct declarations/defintions
	
*/

#ifndef _WASTE_
#include "WASTE.h"
#endif

#if defined(powerc) || defined (__powerc)
#pragma options align=mac68k
#endif


extern	Boolean		gQuitting;

extern	Boolean		gInBackground;

extern	Boolean		gPeriodicTask;

extern	unsigned long		gSleepTime;

extern	Boolean		gInModalState;

extern	RgnHandle	gCursorRgn;

extern	short		gAppResourceFork;

extern	CursHandle	gEditCursor;

extern	CursHandle	gWaitCursor;

extern	acurHandle	gAnimWatchCursor;

extern	Boolean		gHasColorQD;

extern	Boolean		gHasColorPicker;

extern	short		gCurrentRadio;

extern	DialogRef	gModelessDialog;

extern	DialogRef	gMovableModalDialog;

extern	DialogRef	gHelpDialog;

extern	WindowRef	gClipboardWindow;

extern	Boolean		gHasDragAndDrop;

extern	Boolean		gHasTextServices;

extern	Boolean		gHasSpeechManager;

extern	Boolean		gHasNotification;

extern	Boolean		gCanRecordSound;

extern	THPrint		gPrinterRecord;

extern	TPPrPort    gThePrinterPort;

extern	short		gHelpItem;

extern	short		gNewWindowCount;

extern	ModalFilterUPP	gMyStdDlogFilterProc;

extern	NMRec		gNotifyRec;

extern	Boolean		gNotifying;

extern	Str255		gNotifyStr;

extern	FSSpec		gPrefsFileSpec;

extern	WindowRef	gFirstWindow;

extern	short		gNumWindows;

extern	Boolean		gWritePrefs;

struct ScrollBarPair
{
	ControlRef	v;
	ControlRef	h;
};

typedef struct ScrollBarPair ScrollBarPair, *ScrollBarPairPtr, **ScrollBarPairHandle;

// a DocumentRecord is a window record with additional fields

struct DocumentRecord
{
	WindowRef			owner;			// the window
	ScrollBarPair 		scrollBars;		// its scroll bars
	WEReference 		we;				// its WASTE instance
	Handle 				fileAlias;		// alias to associated file
	long				nextWindow;		// reference to the next window in our window list for
										// management of the Windows menu. See HASMenuWindows.c
										// for how this is used
	long				refCon;			// a refCon for attaching any extra data you might want to.
};  // DocumentRec
typedef struct DocumentRecord DocumentRecord, *DocumentPtr, **DocumentHandle;


// this struct contains all our preferences settings

struct HASPreferences
{
	// *** prefs from the 0.9a2 release ***
	
	Str255			prefVers;			// save the version # of HAS (or your app) that created this file
										// could be good like if the 1.0 version you had 1 prefs struct, but in the 2.0
										// version you changed the prefs struct around, so this allows a check on the prefs
										// file to make sure it's a wad of prefs you can read or will have to change, get it?
	
	// from the "registration" dialog
	
	Str255			userName;			// for the "registration" dialog: the user's name
	Str255			userOrg;			// for the "registration" dialog: the user's organization
	
	// default text stuff
	// I don't use the TextStyle struct cause that saves the font as a fontID number, and ID's
	// have the potential (tho slim) to change.  Using the name can give us a little more
	// stability/security
	
	Str255			defFont;			// default font...use name, not fontID cause the name's the same, but the number could change
	Style			defFace;			// default text face/style
	short			defSize;			// default text size
	RGBColor		defColor;			// default text color
	char			defAlign;			// the default text alignment (since alignment isn't part of TextStyle
	long			defFeatures;		// the default features flags (for WENew calls)
	Boolean			useTabHooks;		// use tab hooks? true = yes
	
	// Notification Manager settings
	
	Boolean			useIconNM;			// flash an icon for Notification Manager
	Boolean			useDiamondNM;		// put a diamond by the App's name in the Application Menu?
	Boolean			useSoundNM;			// play a sound for Notification Manager?
	Boolean			useAlertNM;			// display an alert for Notification Manager stuff?
	
	// general prefs
	
	Boolean			createWindow;		// create a window when the app starts up or not (just start up, but don't open a untitled window
	Boolean			playHelpSound;		// play the "Help Me" sound when the Help dialog is brought up?
	Boolean			doSplashScreen;		// display (or not) the opening splash screen upon startup
	Boolean			doStartupSpeech;	// when the Speech Manager gestalt check is made, speak (or not)
										// the "welcome" message.

	// *** no new prefs added for the 0.9a3 release ***
	
	// *** no new prefs added for the 1.0a1 release ***

	// *** prefs added in the 1.0a2 release ***
	
	Boolean			printPageNumbers;	// print page numbers (true) or not (false)
	Str15			printLeftMargin;	// margin settings (inches).  Str15's used for numerous
	Str15			printRightMargin;	// reasons: 1. smaller than a Str255, 2. margins could be
	Str15			printTopMargin;		// fractional (e.g. 1.5, 2.34) and this stores nicely
	Str15			printBottomMargin;	// 3. easier to deal with in the dialog
	Boolean			printDoubleSpaced;	// print double spaced (true) or not (single space) (false)
	Fixed			sVoicePitch;		// text-to-speech's voice pitch
	Fixed			sVoiceRate;			// text-to-speech's voice rate
	Fixed			sVoiceMod;			// text-to-speech's voice modulation
	Str255			sVoiceStr;			// the name of the prefered voice


	// *** this is just to fill blank space to allow for expansion in the future. *** 
	
	// as a note:  i implimented this fill array (to just take up empty space) before the
	// 1.0a2 release.  Originally, it was 4096.  but with the 1.0a2 new prefs, we had to
	// subtract 66 bytes from it.  Why do this?  well, if you look at how the pref file is
	// read in, it's just a block read.  by having the file size of the prefs remain
	// "constant" from version to version, it keeps our read functions simple and consistant
	// while still allowing us room to grow.  (incidentally, the choice to make the original
	// size of the fill array 4k (4096 bytes) was arbitrary...i just wanted a nice size that
	// wasn't too big, but had enough room to grow)
	
	// so, when you add new stuff to the prefs rec, be sure to subtract the variable size
	// from this fill array.  e.g. if you add a Boolean to the rec, subtract 1.  if you
	// add a long, subtract 4.  a Str255, 256.  etc....(if you're in doubt of just how big
	// a structure/variable/data-type will be, write a small little ANSI C program that
	// just does a sizeof on your data.  for example:
	
	/*
		#include <stdio.h>
		
		main()
		{
			// insert your data here, be it a simple variable, a typedef'ed variable
			// or a whole struct.  for example:
			
			struct foo {
				long		x;
				Str255		str;
				OSType		t;
			};
			
			printf( "\nThe size of my data is: %d", sizeof( foo ) );
			
			return 0;
		}
	*/
				
	
	char			fill[3762];


};

typedef struct HASPreferences HASPreferences, *HASPreferencesPtr, **HASPreferencesHandle;
typedef HASPreferencesHandle HASPrefsHandle, HASPrefsHndl;

// can't declare this extern variable until after the definition of HASPreferences has been made

extern	HASPreferences	gMyPrefs;			// holds our preferences settings


#if defined(powerc) || defined (__powerc)
#pragma options align=reset
#endif
