/*
	HASMovableModal.h from Hsoi's App Shell 1995-1997 John C. Daub.  All rights reserved.
	
	This is the corresponding header file to HASMovableModal.c.  This is not my own work,
	but rather the work of Marco Piovanelli from his MovableModal library version 2.0.
	
	I just modified things here and there to work with Hsoi's App Shell, plus any
	necessary Copland modifications.

	from Marco's:
	
	C interface to the MovableModal library

	The MovableModal library includes some simple routines to handle
	movable modal dialogs in much the same way as non-movable modal dialogs are
	handled, but following Apple HIGs on the subject

	Copyright  1993-1995 Marco Piovanelli
 
 */

#ifndef __DIALOGS__
#include <Dialogs.h>
#endif

/*
 *  Call DisableMenuBar soon after putting up your movable modal dialog (the
 *  frontmost window is assumed to be your dialog).
 *  Pass the menu ID of your Edit menu in editMenuID, or 0 if you don't have one.
 *  DisableMenuBar disables all menus except the system menus
 *  (Help, Keyboard and Application).
 *  It enables Cut, Copy and Paste in the Edit menu if your dialog contains edit
 *  fields.
 *  Pass the ID of a valid 'hmnu' resource in hmnuID if you want menu
 *  help string remapping to take place, as described in "Toolbox
 *  M.TB.MovableModalDialog"; otherwise pass -1 (if the Help Manager isn't
 *  available, nothing will happen anyway)
 */

pascal void DisableMenuBar(short editMenuID, short hmnuID);

/*
 *  Call ReEnableMenuBar soon after bringing down your movable modal dialog box.
 *  ReEnableMenuBar will restore the previous enableFlags for all menus in
 *  the menu bar
 */

pascal void ReEnableMenuBar(void);

/* 
 *  MovableModalDialog is the routine that does most of the work.
 *  It's very much like the Toolbox routine ModalDialog in system 7.x.
 *  MovableModalDialog allows access to the menu bar (even under system 6.0.x)
 *  and major context switches.
 *  You normally will want to know when a context switch takes place while your
 *  dialog is in front: to do this, you have to check for events of type osEvt
 *  from within your filter procedure
 */

pascal void MovableModalDialog(ModalFilterUPP filterProc, short *itemHit);
