/*
	HASSoundSpeech.h from Hsoi's App Shell  1995-1997 John C. Daub.  All rights reserved.
	
	This is the corresponding header file to HASSoundSpeech.c
*/

#ifndef _WASTE_
#include "WASTE.h"
#endif

// constants

// the speech dialog items

enum {
	kDialogSpeechOptions = 1100,

	kDlgItemVoicePopmenu = 6,
	// ok and cancel are the standard 1 and 2
	kDlgItemSample = 3,					// sample button
	kDlgItemPitch = 7,					// pitch edit box
	kDlgItemRate = 8,					// rate edit box
	kDlgItemMod = 17,					// modulation edit box
	kDlgItemPitchUp = 9,				// pitch increase rect
	kDlgItemPitchDown = 10,				// pitch decrease rect
	kDlgItemRateUp = 12,				// rate increase rect
	kDlgItemRateDown = 13,				// rate decrease rect
	kDlgItemModUp = 18,					// modulation increase rect
	kDlgItemModDown = 19,				// modulation decrease rect
	kDlgItemPitchArrows = 11,			// rect for pitch Arrows
	kDlgItemRateArrows = 14,			// rect for rate arrows
	kDlgItemModArrows = 20,				// rect for modulation arrows
	kDlgItemOKOutline = 15,				// used to outline default OK button
	kDlgItemVoiceDescription = 21
};

enum {
	kPopmenuVoice = 1103				// the popup menu ID
};

enum {
	kSpeechErrorAlert = 1000
};

// voice string Res ID's

enum {
	kVoiceStringsID		=	1000,
	kStrMale			=	1,
	kStrFemale			=	2,
	kStrNeuter			=	3,
	kStrYearsOld		=	4,
	kStrPause			=	5,	// these 4 are menu item text toggles
	kStrResume			=	6,
	kStrTurnOn			=	7,
	kStrTurnOff			=	8,
	kStrNoSpeechMgr		=	9
};

// various other constants
enum {
	kMinPitch = 0,						// minimum pitch
	kMaxPitch = 100,					// maximum pitch
	kMinRate = 1,						// minimum rate
	kMaxRate = 400,						// maximum rate
	kMinMod = 0,						// minimum modulation
	kMaxMod = 100,						// maximum modulation
	kMaxVoiceCount = 40					// maximum number of voices in popmenu
};


typedef enum { off, word, sentence } HiliteMethod;


// global variables

extern	SpeechChannel		gSpeechChannel;
extern	HiliteMethod		gHiliteMethod;
extern	Boolean				gSpeechOn;
extern	Boolean				gHiliting;
extern	Boolean				gPaused;


// function protos

OSErr			HsoiBuildVoiceMenu( void );
void			HsoiGetVoiceMenuSelection( Handle cntrlHdl, Str255 voiceStr );
void			HsoiSetVoiceMenuSelection( ConstStr255Param selVoiceStr, ControlRef cntrlHdl );
pascal void		HsoiDrawVoiceDescBox( WindowRef dlg, short itemNo );
void			HsoiDoSpeechOptionsDialog( void );
pascal Boolean	hsoiSpeechOptionsDialogFilter( DialogRef theDialog, EventRecord *event, short *item );
void			HsoiHandleSpeechOptionsDialog( short theItem, DialogRef dlg );


void			HsoiDisplaySpeechError( OSErr err );
void			HsoiInitSpeechStuff( void );
short			HsoiGetVoiceIndex( Str255 voiceStr );
pascal void		HsoiMyWordCallback( SpeechChannel chann, long refCon, long wordPos, short wordLen );
void			HsoiReadTheText( long selStart, long selEnd, WEReference txtHdl );
void			HsoiDoReadDoc( WindowRef window ); // read entire document
void			HsoiDoReadFromCursor( WindowRef window );
void			HsoiDoReadSelection( WindowRef window );
OSErr			HsoiDoStop( void ); // stop reading
void			HsoiDoPause( void ); // pause/resume
void			HsoiDoSpeechOnOff( void ); // 'Speech Off' menu opt
void			HsoiDoHiliteMenu( short item );  //selection from AutoHilite submenu
void			HsoiGetNextSelection( long *selStart, long *selEnd, WEReference txtHdl );
void			HsoiRunHiliter( EventRecord *event );

Boolean			HsoiIsSpacer( long selStart, WEReference we, short inWhat );

void			HsoiAdjustSoundMenu( WindowRef window );
